# --==--==--==--==--==--==--==--==--==--==--==--==--==--==--==-- #
# Bruno Charest 
# 2022-08-09 
# 
# __ DESCRIPTIONS __
# web_utils : procedure related web interface 
#
# --==--==--==--==--==--==--==--==--==--==--==--==--==--==--==-- #
import xlsx # read dashbord.xlsx
import jester
import joplin_utils


# --==--==--==--==--==--==--==--==--==--==-- #
# TYPE : Selected Option for master web page
# --==--==--==--==--==--==--==--==--==--==-- #
type
  selectedOption* = enum
    newNote = "New Note", search = "Search", shortcuts = "Shortcuts",
        notes = "Notes", notebooks = "Notesbooks", tags = "Tags",
            notes_selectednote = "Notes-SelectedNote", dashbord = "Dashboard"


# --==--==--==--==--==--==--==--==--==--==-- #
# TYPE : Data Informations for Left Colomn
# --==--==--==--==--==--==--==--==--==--==-- #
type ColomnLeftData* = ref object of RootObj
  j_status*: bool
  option*: selectedOption
  j_notes*: joplin_notes
  j_notes_nb*: int
  j_notebooks*: joplin_notebooks
  j_notebooks_nb*: int
  j_tags*: joplin_tags
  j_tags_nb*: int
  req*: Request

# --==--==--==--==--==--==--==--==--==--==-- #
# TYPE : Data Informations for Right Colomn
# --==--==--==--==--==--==--==--==--==--==-- #
type ColomnRightData* = ref object of RootObj
  j_status*: bool
  option*: selectedOption
  j_SelectedNote*: joplin_note
  j_notebooksNote*: joplin_notebooks
  j_tagsNote*: joplin_tags
  req*: Request


# --==--==--==--==--==--==--==--==--==--==-- #
# TYPE : Dashbord information
# --==--==--==--==--==--==--==--==--==--==-- #
type DashbordData* = ref object of RootObj
  position*: seq[int]
  ext_link*: seq[string]
  int_link*: seq[string]
  title*: seq[string]
  category*: seq[string]
  icon*: seq[string]
  open_method*: seq[string]
  tag*: seq[string]
  hotkey*: seq[string]
  color*: seq[string]
  req*: Request


# --==--==--==--==--==--==--==--==--==--==--==--==--==--==-- #
# PROC :
# --==--==--==--==--==--==--==--==--==--==--==--==--==--==-- #
proc getDashbordData(ddata: var DashbordData) =
  let
    data = parseExcel("data/dashbord.xlsx", header = true)
    sheetName = "dashbord"
  echo data[sheetName]

  let rows = data[sheetName].toSeq(true)
  echo rows.len()
  # for i in 0 ..data[sheetName]:
  #   ddata.position[i] = row[i]
  for row in rows:
    echo "position: " & row[0]
    echo "URL externe: " & row[1]
